diff --git a/cli.py b/cli.py
old mode 100644
new mode 100755
index 6056d38..aa73278
--- a/cli.py
+++ b/cli.py
@@ -745,34 +1017,46 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
 
         else:
             # go through the userlist - look for items that are local rpms. If we find them
-            # pass them off to localInstall() and then move on
-            localupdates = []
+            # pass them off to installLocal() and then move on
             for item in userlist:
                 if (item.endswith('.rpm') and (yum.misc.re_remote_url(item) or
                                                os.path.exists(item))):
-                    localupdates.append(item)
-            
-            if len(localupdates) > 0:
-                self.localInstall(filelist=localupdates, updateonly=1)
-                for item in localupdates:
-                    userlist.remove(item)
-                
-            for arg in userlist:
-                if not self.update(pattern=arg, update_to=update_to):
-                    self._checkMaybeYouMeant(arg)
+                    txmbrs = self.installLocal(item, updateonly=1)
+                    self._install_upgraded_requires(txmbrs)
+                    continue
+
+                txmbrs = self.update(pattern=item, update_to=update_to)
+                self._install_upgraded_requires(txmbrs)
+                if not txmbrs:
+                    self._checkMaybeYouMeant(item)
 
         if len(self.tsInfo) > oldcount:
             change = len(self.tsInfo) - oldcount
-            return 2, [P_('%d package marked for Update', '%d packages marked for Update', change) % change]
+            return 2, [P_('%d package marked for update', '%d packages marked for update', change) % change]
         else:
-            return 0, [_('No Packages marked for Update')]
+            return 0, [_('No packages marked for update')]
 
     #  Note that we aren't in __init__ yet for a couple of reasons, but we 
     # probably will get there for 3.2.28.
     def distroSyncPkgs(self, userlist):
-        """ This does either upgrade/downgrade, depending on if the latest
-            installed version is older or newer. We allow "selection" but not
-            local packages (use tmprepo, or something). """
+        """Upgrade or downgrade packages to match the latest versions
+        available in the enabled repositories.
+
+        :param userlist: list of names or wildcards specifying
+           packages to synchronize with the repositories.  If the
+           first string in *userlist* is "full", packages will also be
+           reinstalled if their checksums do not match the checksums
+           in the repositories.  If *userlist* is an empty list or
+           only contains "full", every installed package will be
+           synchronized
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
 
         level = 'diff'
         if userlist and userlist[0] in ('full', 'diff', 'different'):
@@ -831,6 +1115,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                         continue
 
                     nayi = napkg.yumdb_info
+                    found = False
                     for apkg in self.pkgSack.searchPkgTuple(napkg.pkgtup):
                         if ('checksum_type' in nayi and
                             'checksum_data' in nayi and
@@ -861,19 +1146,58 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 dupdates.extend(self.downgrade(name=n, epoch=e, ver=v, rel=r))
 
         if dupdates:
-            return 2, [P_('%d package marked for Distribution Synchronization', '%d packages marked for Distribution Synchronization', len(dupdates)) % len(dupdates)]
+            return 2, [P_('%d package marked for distribution synchronization', '%d packages marked for distribution synchronization', len(dupdates)) % len(dupdates)]
         else:
-            return 0, [_('No Packages marked for Distribution Synchronization')]
+            return 0, [_('No packages marked for distribution synchronization')]
 
-    def erasePkgs(self, userlist):
-        """take user commands and populate a transaction wrapper with packages
-           to be erased/removed"""
-        
-        oldcount = len(self.tsInfo)
+    def erasePkgs(self, userlist, pos=False, basecmd='remove'):
+        """Take user commands and populate a transaction wrapper with
+        packages to be erased.
+
+        :param userlist: a list of names or wildcards specifying
+           packages to erase
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
 
         all_rms = []
         for arg in userlist:
-            rms = self.remove(pattern=arg)
+            if pos:
+                rms = self.remove(po=arg)
+                if rms:
+                    all_rms.extend(rms)
+                continue
+
+            if False: pass
+            elif basecmd in ('erase-n', 'remove-n'):
+                rms = self.remove(name=arg)
+            elif basecmd in ('erase-na', 'remove-na'):
+                try:
+                    n,a = arg.rsplit('.', 1)
+                except:
+                    self.verbose_logger.warning(_('Bad %s argument %s.'),
+                                                basecmd, arg)
+                    continue
+                rms = self.remove(name=n, arch=a)
+            elif basecmd in ('erase-nevra', 'remove-nevra'):
+                try:
+                    nevr,a = arg.rsplit('.', 1)
+                    n,ev,r = nevr.rsplit('-', 2)
+                    e,v    = ev.split(':', 1)
+                except:
+                    self.verbose_logger.warning(_('Bad %s argument %s.'),
+                                                basecmd, arg)
+                    continue
+                rms = self.remove(name=n, epoch=e, version=v, release=r, arch=a)
+            else:
+                assert basecmd in ('erase', 'remove'), basecmd
+                rms = self.remove(pattern=arg)
+
             if not rms:
                 self._checkMaybeYouMeant(arg, always_output=False, rpmdb_only=True)
             all_rms.extend(rms)
@@ -884,12 +1208,24 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             return 0, [_('No Packages marked for removal')]
     
     def downgradePkgs(self, userlist):
-        """Attempts to take the user specified list of packages/wildcards
-           and downgrade them. If a complete version number if specified,
-           attempt to downgrade them to the specified version"""
+        """Attempt to take the user specified list of packages or
+        wildcards and downgrade them. If a complete version number if
+        specified, attempt to downgrade them to the specified version
+
+        :param userlist: a list of names or wildcards specifying
+           packages to downgrade
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
 
         oldcount = len(self.tsInfo)
         
+        done = False
         for arg in userlist:
             if (arg.endswith('.rpm') and (yum.misc.re_remote_url(arg) or
                                           os.path.exists(arg))):
@@ -905,26 +1241,44 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                                         self.term.MODE['bold'], arg,
                                         self.term.MODE['normal'])
                 self._maybeYouMeant(arg)
+            else:
+                done = True
         if len(self.tsInfo) > oldcount:
             change = len(self.tsInfo) - oldcount
             return 2, [P_('%d package to downgrade', '%d packages to downgrade', change) % change]
+
+        if not done:
+            return 1, [_('Nothing to do')]
         return 0, [_('Nothing to do')]
         
     def reinstallPkgs(self, userlist):
-        """Attempts to take the user specified list of packages/wildcards
-           and reinstall them. """
+        """Attempt to take the user specified list of packages or
+        wildcards and reinstall them.
+
+        :param userlist: a list of names or wildcards specifying
+           packages to reinstall
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
 
         oldcount = len(self.tsInfo)
 
+        done = False
         for arg in userlist:
             if (arg.endswith('.rpm') and (yum.misc.re_remote_url(arg) or
                                           os.path.exists(arg))):
-                self.reinstallLocal(arg)
+                txmbrs = self.reinstallLocal(arg)
+                self._install_upgraded_requires(txmbrs)
                 continue # it was something on disk and it ended in rpm
                          # no matter what we don't go looking at repos
 
             try:
-                self.reinstall(pattern=arg)
+                txmbrs = self.reinstall(pattern=arg)
             except yum.Errors.ReinstallRemoveError:
                 self._checkMaybeYouMeant(arg, always_output=False)
             except yum.Errors.ReinstallInstallError, e:
@@ -940,22 +1294,38 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             except yum.Errors.ReinstallError, e:
                 assert False, "Shouldn't happen, but just in case"
                 self.verbose_logger.log(yum.logginglevels.INFO_2, e)
+            else:
+                done = True
+                self._install_upgraded_requires(txmbrs)
+
         if len(self.tsInfo) > oldcount:
             change = len(self.tsInfo) - oldcount
             return 2, [P_('%d package to reinstall', '%d packages to reinstall', change) % change]
+
+        if not done:
+            return 1, [_('Nothing to do')]
         return 0, [_('Nothing to do')]
 
     def localInstall(self, filelist, updateonly=0):
-        """handles installs/updates of rpms provided on the filesystem in a 
-           local dir (ie: not from a repo)"""
-           
+        """Install or update rpms provided on the file system in a
+        local directory (i.e. not from a repository).
+
+        :param filelist: a list of names specifying local rpms
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """           
         # read in each package into a YumLocalPackage Object
         # append it to self.localPackages
         # check if it can be installed or updated based on nevra versus rpmdb
         # don't import the repos until we absolutely need them for depsolving
 
         if len(filelist) == 0:
-            return 0, [_('No Packages Provided')]
+            return 0, [_('No packages provided')]
 
         installing = False
         for pkg in filelist:
@@ -971,23 +1341,29 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             return 2, [_('Package(s) to install')]
         return 0, [_('Nothing to do')]
 
-    def returnPkgLists(self, extcmds, installed_available=False):
-        """Returns packages lists based on arguments on the cli.returns a 
-           GenericHolder instance with the following lists defined:
-           available = list of packageObjects
-           installed = list of packageObjects
-           updates = tuples of packageObjects (updating, installed)
-           extras = list of packageObjects
-           obsoletes = tuples of packageObjects (obsoleting, installed)
-           recent = list of packageObjects
-
-           installed_available = that the available package list is present
-                                 as .hidden_available when doing any of:
-                                 all/available/installed
-           """
-        
+    def returnPkgLists(self, extcmds, installed_available=False, repoid=None):
+        """Return a :class:`yum.misc.GenericHolder` object containing
+        lists of package objects that match the given names or wildcards.
+
+        :param extcmds: a list of names or wildcards specifying
+           packages to list
+        :param installed_available: whether the available package list
+           is present as .hidden_available when doing all, available,
+           or installed
+        :param repoid: a repoid that all packages should belong to
+
+        :return: a :class:`yum.misc.GenericHolder` instance with the
+           following lists defined::
+
+             available = list of packageObjects
+             installed = list of packageObjects
+             updates = tuples of packageObjects (updating, installed)
+             extras = list of packageObjects
+             obsoletes = tuples of packageObjects (obsoleting, installed)
+             recent = list of packageObjects
+        """
         special = ['available', 'installed', 'all', 'extras', 'updates', 'recent',
-                   'obsoletes']
+                   'obsoletes', 'distro-extras']
         
         pkgnarrow = 'all'
         done_hidden_available = False
@@ -1003,7 +1379,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 pkgnarrow = extcmds.pop(0)
             
         ypl = self.doPackageLists(pkgnarrow=pkgnarrow, patterns=extcmds,
-                                  ignore_case=True)
+                                  ignore_case=True, repoid=repoid)
         if self.conf.showdupesfromrepos:
             ypl.available += ypl.reinstall_available
 
@@ -1017,8 +1393,25 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return ypl
 
     def search(self, args):
-        """cli wrapper method for module search function, searches simple
-           text tags in a package object"""
+        """Search for simple text tags in a package object. This is a
+        cli wrapper method for the module search function.
+
+        :param args: list of names or wildcards to search for.
+           Normally this method will begin by searching the package
+           names and summaries, and will only search urls and
+           descriptions if that fails.  However, if the first string
+           in *args* is "all", this method will always search
+           everything
+        :return: a tuple where the first item is an exit code, and
+           the second item is a generator if the search is a
+           successful, and a list of error messages otherwise
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         
         # call the yum module search function with lists of tags to search
         # and what to search for
@@ -1053,7 +1446,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                         print ""
                     else:
                         mkeys = set(keys)
-                    _print_match_section(_('N/S Matched: %s'))
+                    _print_match_section(_('N/S matched: %s'))
                     okeys = keys
                 pos.add(po)
                 akeys.update(keys)
@@ -1104,13 +1497,24 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 self.logger.warning(_('Warning: No matches found for: %s'), arg)
 
         if not akeys:
-            return 0, [_('No Matches found')]
+            return 0, [_('No matches found')]
         return 0, matching
 
     def deplist(self, args):
-        """cli wrapper method for findDeps method takes a list of packages and 
-            returns a formatted deplist for that package"""
+        """Print out a formatted list of dependencies for a list of
+        packages.  This is a cli wrapper method for
+        :class:`yum.YumBase.findDeps`.
 
+        :param args: a list of names or wildcards specifying packages
+           that should have their dependenices printed
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         pkgs = []
         for arg in args:
             if (arg.endswith('.rpm') and (yum.misc.re_remote_url(arg) or
@@ -1118,10 +1522,12 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
                 thispkg = yum.packages.YumUrlPackage(self, self.ts, arg)
                 pkgs.append(thispkg)
             elif self.conf.showdupesfromrepos:
-                pkgs.extend(self.pkgSack.returnPackages(patterns=[arg]))
+                pkgs.extend(self.pkgSack.returnPackages(patterns=[arg],
+                                                        ignore_case=True))
             else:                
                 try:
-                    pkgs.extend(self.pkgSack.returnNewestByName(patterns=[arg]))
+                    pkgs.extend(self.pkgSack.returnNewestByName(patterns=[arg],
+                                                              ignore_case=True))
                 except yum.Errors.PackageSackError:
                     pass
                 
@@ -1131,10 +1537,19 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return 0, []
 
     def provides(self, args):
-        """use the provides methods in the rpmdb and pkgsack to produce a list 
-           of items matching the provides strings. This is a cli wrapper to the 
-           module"""
-        
+        """Print out a list of packages that provide the given file or
+        feature.  This a cli wrapper to the provides methods in the
+        rpmdb and pkgsack.
+
+        :param args: the name of a file or feature to search for
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         old_sdup = self.conf.showdupesfromrepos
         # For output, as searchPackageProvides() is always in showdups mode
         self.conf.showdupesfromrepos = True
@@ -1147,6 +1562,8 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             paths = set(sys.path + os.environ['PATH'].split(':'))
             nargs = []
             for arg in args:
+                if not arg:
+                    continue
                 if yum.misc.re_filename(arg) or yum.misc.re_glob(arg):
                     continue
                 for path in paths:
@@ -1158,25 +1575,82 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         self.conf.showdupesfromrepos = old_sdup
 
         if len(matching) == 0:
-            return 0, ['No Matches found']
+            return 0, ['No matches found']
         
         return 0, []
     
     def resolveDepCli(self, args):
-        """returns a package (one per user arg) that provide the supplied arg"""
-        
+        """Print information about a package that provides the given
+        dependency.  Only one package will be printed per dependency.
+
+        :param args: a list of strings specifying dependencies to
+           search for
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+
+        not_found = set()
         for arg in args:
             try:
+                ipkg = self.returnInstalledPackageByDep(arg)
+            except yum.Errors.YumBaseError:
+                ipkg = None
+            else:
+                self.verbose_logger.info("  %s:", arg)
+                self.verbose_logger.info("%s %s" % (ipkg.envra,
+                                                    ipkg.ui_from_repo))
+            try:
                 pkg = self.returnPackageByDep(arg)
             except yum.Errors.YumBaseError:
-                self.logger.critical(_('No Package Found for %s'), arg)
+                if not ipkg:
+                    not_found.add(arg)
             else:
-                msg = '%s:%s-%s-%s.%s' % (pkg.epoch, pkg.name, pkg.version, pkg.release, pkg.arch)
-                self.verbose_logger.info(msg)
+                if not ipkg:
+                    self.verbose_logger.info("  %s:", arg)
+                if not pkg.verEQ(ipkg):
+                    self.verbose_logger.info("%s %s" % (pkg.envra,
+                                                        pkg.ui_from_repo))
+
+        if not_found:
+            self.logger.critical(_('Error: No packages found for:\n  %s'),
+                                 "\n  ".join(sorted(not_found)))
 
         return 0, []
     
     def cleanCli(self, userlist):
+        """Remove data from the yum cache directory.  What data is
+        removed depends on the options supplied by the user.
+
+        :param userlist: a list of options.  The following are valid
+           options::
+
+             expire-cache = Eliminate the local data saying when the
+               metadata and mirror lists were downloaded for each
+               repository.
+             packages = Eliminate any cached packages
+             headers = Eliminate the header files, which old versions
+               of yum used for dependency resolution
+             metadata = Eliminate all of the files which yum uses to
+               determine the remote availability of packages
+             dbcache = Eliminate the sqlite cache used for faster
+               access to metadata
+             rpmdb = Eliminate any cached datat from the local rpmdb
+             plugins = Tell any enabled plugins to eliminate their
+               cached data
+             all = do all of the above
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         hdrcode = pkgcode = xmlcode = dbcode = expccode = 0
         pkgresults = hdrresults = xmlresults = dbresults = expcresults = []
         msg = self.fmtKeyValFill(_('Cleaning repos: '), 
@@ -1184,7 +1658,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         self.verbose_logger.log(yum.logginglevels.INFO_2, msg)
         if 'all' in userlist:
             self.verbose_logger.log(yum.logginglevels.INFO_2,
-                _('Cleaning up Everything'))
+                _('Cleaning up everything'))
             pkgcode, pkgresults = self.cleanPackages()
             hdrcode, hdrresults = self.cleanHeaders()
             xmlcode, xmlresults = self.cleanMetadata()
@@ -1200,10 +1674,10 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
             return code, []
             
         if 'headers' in userlist:
-            self.logger.debug(_('Cleaning up Headers'))
+            self.logger.debug(_('Cleaning up headers'))
             hdrcode, hdrresults = self.cleanHeaders()
         if 'packages' in userlist:
-            self.logger.debug(_('Cleaning up Packages'))
+            self.logger.debug(_('Cleaning up packages'))
             pkgcode, pkgresults = self.cleanPackages()
         if 'metadata' in userlist:
             self.logger.debug(_('Cleaning up xml metadata'))
